/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2003-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/FSCL.txt
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Josh Wilsdon <josh@wizard.ca>
 * Version: $Header: /web/programmers/cvs/magicmail-backend/common/stopwatch.c,v 1.3 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 *
 */

/* stanadard libraries */
#include <sys/time.h>
#include <time.h>
#include <stdio.h>

#include "stopwatch.h"

double stopwatch(stopwatch_t * start, int action)
{
    struct timeval stop;
    long elapsed_secs, elapsed_usecs;
    double elapsed;

    switch (action) {
        case STOPWATCH_START:
            if (gettimeofday(start, NULL) != 0) {
                /* perror("gettimeofday()"); */
                break;
            }
            break;
        case STOPWATCH_STOP:
            if (start->tv_sec == 0) {
                /* stopwatch has not been started */
                return ((double) -1);
                break;
            }
            if (gettimeofday(&stop, NULL) != 0) {
                /* perror("gettimeofday()"); */
                break;
            }
            elapsed_secs = stop.tv_sec - start->tv_sec;
            elapsed_usecs = stop.tv_usec - start->tv_usec;
            if (elapsed_usecs < 0) {
                --elapsed_secs;
                elapsed_usecs += 1000000;
            }
            elapsed =
                (double) elapsed_secs +
                ((double) elapsed_usecs / (double) 1000000);
            return (elapsed);

            /* NOTREACHED */
            break;
        default:
            /* invalid stopwatch action */
            return ((double) -2);
            break;
    }

    return (0);
}
