/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2002-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/FSCL.txt
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Burton Samograd <burton@wizard.ca>
 *
 * CVS Id: $Header: /web/programmers/cvs/magicmail-backend/lmlibs/examples/lmalloc-test.c,v 1.3 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#include <stdlib.h>
#include <stdio.h>

#include <liblm.h>

int main(int argc, char **argv)
{
    int *ptr1, *ptr2, *ptr3, *ptr4;
    char *oldptr, *newptr;

    ptr1 = ptr2 = ptr3 = ptr4 = NULL;

    oldptr = newptr = NULL;
    LM_MALLOC(oldptr, 100);
    newptr = oldptr;
    LM_MEMASSERT(newptr);
    LM_FREE(newptr);
    /* FIXME This next line will cause a seg fault */
    /* LM_FREE(oldptr); */

    LM_MALLOC(ptr1, sizeof(int) * 10);
    LM_FREE(ptr1);

    LM_MALLOC(ptr2, sizeof(int) * 20);

    LM_MALLOC(ptr3, sizeof(int) * 50);
    LM_MALLOC(ptr4, sizeof(int) * 200);

    printf("\n\nThis should not produce an error...\n\n");
    memset(ptr2, 0, sizeof(int) * 20);
    LM_MEMASSERT(ptr2);
    printf("\n\nThis should bring up an errro...\n\n");
    memset(ptr2, 0, sizeof(int) * 21);
    LM_MEMASSERT(ptr2);

    LM_MEMSTAT(stderr);

    LM_FREE(ptr2);
    LM_FREE(ptr3);

    /* Should always be called at the end of the program 
       to show any allocated memory left over */
    LM_MEMDUMP(stderr);

    LM_FREE(ptr1);
    printf
        ("\n\nThis should bring up an error and will crash if execution continues...\n\n");
    LM_FREE(ptr1);

    LM_MEMSTAT(stderr);

    return 0;
}
