/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2002-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/FSCL.txt
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Burton Samograd <burton@wizard.ca>
 *
 * CVS Id: $Header: /web/programmers/cvs/magicmail-backend/lmlibs/liblm_config.h,v 1.3 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#ifndef _LMLIBCONFIG_H
#define _LMLIBCONFIG_H

/* Comment out any of these to not include the functionality in final build */
/* NOTE We might just get rid of this later, but seems like a good idea for
   now for some reason */
#define LM_USE_DEBUG
#define LM_USE_ALLOC 
#define LM_USE_LOGGER 
#define LM_USE_CONFIG 
#define LM_USE_CONTAINER 

/* LM_ALLOC config */
/* Maximum size before warning during allocation */
#ifndef LM_ALLOC_MAX_WARN_SIZE
#define LM_ALLOC_MAX_WARN_SIZE (1024*1024)
#endif

/* LM_STRING config */
/* Maximum length before warning about long string during assert */
#ifndef LM_STRING_MAX_WARN_SIZE
#define LM_STRING_MAX_WARN_SIZE 1024*1024
#endif

/* LM_CONFIG control defines for which types of configuration files to
   compile in.  Default is all  */
#ifdef LM_USE_CONFIG

#ifndef USE_LM_CONFIG_CONTROL
#define USE_LM_CONFIG_CONTROL 
#endif

#ifndef USE_LM_CONFIG_CONTROL
#define USE_LM_CONFIG_CONTROL
#endif

#ifdef USE_LM_DATABASE
#ifndef USE_LM_CONFIG_DATABASE
#define USE_LM_CONFIG_DATABASE
#endif
#endif

#ifndef USE_LM_CONFIG_FLATFILE
#define USE_LM_CONFIG_FLATFILE
#endif

#ifndef USE_LM_CONFIG_ENV
#define USE_LM_CONFIG_ENV 
#endif

#endif

#endif /* _LMLIBCONFIG_H */
