
/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2002-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Burton Samograd <burton@wizard.ca>
 *
 * CVS Id: $Header: /web/programmers/cvs/magicmail-backend/magic-smtpd/smtp_auth.h,v 1.3 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */


#ifndef _MSD_AUTH
#define _MSD_AUTH

#include <liblm.h>

/* Define authorization types */
#define LM_AUTH_POSTGRES 

/* Return codes for msd_do_auth */
#define LM_AUTH_OK 0
#define LM_AUTH_FAILED 1
#define LM_AUTH_NO_USER 2
#define LM_AUTH_UNSUPPORTED -1
#define LM_AUTH_ERROR_DB -2
#define LM_AUTH_CANCEL -3
#define LM_AUTH_BAD_DATA -4
#define LM_AUTH_ERROR -5

int msd_do_auth(int type, lm_string_t username64);

/* these are external */
int msd_do_auth_db(int type, lm_string_t username, lm_string_t password);
int msd_do_auth_dbfile(int type, lm_string_t username, lm_string_t password);
int msd_do_auth_chkp(int type, char *user, char *pass);

#endif /* _MSD_AUTH */
