/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2002-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Burton Samograd <burton@wizard.ca>
 *
 * CVS Id: $Header: /web/programmers/cvs/magicmail-backend/magic-smtpd/smtp_check.h,v 1.5 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */


#ifndef _MSD_SMTP_CHECKS
#define _MSD_SMTP_CHECKS

/* lmlibs */
#include <liblm.h>

int smtp_blocking(void);
int valid_bounce(lm_string_t fromdomain);
int check_ip_reverse_dns(void);
int require_helo(lm_string_t helostring);
int valid_helo_domain(lm_string_t domain);
int ip_helo_domain(lm_string_t domain);
int resolve_helo_domain(lm_string_t domain);
int valid_from_domain(lm_string_t domain);
int block_mail_from_self(lm_string_t from, lm_string_t to);
int block_ip_in_addr(lm_string_t addr);
int require_full_addr(lm_string_t rcptaddr);
int mail_from_strict_addr_parse(lm_string_t addr, int rfc);
int check_dynamic_reverse_dns(void);
int block_all_mail(void);

#endif /* _MSD_SMTP_CHECKS */
