/*
 * COPYRIGHT INFORMATION - DO NOT REMOVE
 * Copyright (c) 2003-2005 LinuxMagic Inc. All Rights Reserved.
 *
 * This file contains Original Code and/or Modifications of Original Code as
 * defined in and that are subject to the Free Source Code License Version
 * 1.0 (the 'License'). You may not use this file except in compliance with
 * the License. Please obtain a copy of the License at:
 *
 * http://www.linuxmagic.com/opensource/licensing/FSCL.txt
 *
 * and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND LINUXMAGIC HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. Please see
 * the License for the specific language governing rights and limitations
 * under the License."
 *
 * Please read the terms of this license carefully. By using or downloading
 * this software or file, you are accepting and agreeing to the terms of this
 * license with LinuxMagic Inc. If you are agreeing to this license on behalf
 * of a company, you represent that you are authorized to bind the company to
 * such a license. If you do not meet this criterion or you do not agree to
 * any of the terms of this license, do NOT download, distribute, use or alter
 * this software or file in any way.
 *
 * Author(s): Josh Wilsdon <josh@wizard.ca>
 *
 * CVS Id: $Header: /web/programmers/cvs/magicmail-backend/magic-smtpd/valid_user_check_dbfile.c,v 1.3 2005/12/19 21:13:49 josh Exp $
 *
 * DO NOT MODIFY WITHOUT CONSULTING THE LICENSE
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <liblm.h>
#include <common/controls.h>
#include <common/dbfile.h>
#include "valid_user_check.h"

extern config_t config;
extern config_type_t config_type_info[];

/* 
  Return:
    0 does exist
    1 does not exist
   -1 error
*/
int msd_check_rcpt_user_dbfile(lm_string_t * paddr)
{
    DB *dbp;
    char *realuser, *user;
    int ret;

    dbp = openDBFile(config.user_info_dbfile);
    if (dbp == NULL) {
        return (-1);
    }

    /* TODO: append default domain if needed */

    user = strdup(LM_STRING_BUFFER(*paddr));
    if (user == NULL) {
        closeDBFile(dbp);
        return (-1);
    }
    ret = getRealUser(dbp, user, &realuser);
    free(user);

    closeDBFile(dbp);

    if (ret == 0) {
        // printf("user exists as [%s]\n", realuser);
        free(realuser);
        // printf("RETURNING\n");
        return (0);
    } else if (ret == 1) {
        syslog(LOG_DEBUG, "user does not exist %s", LM_STRING_BUFFER(*paddr));
        return (1);
    } else {
        syslog(LOG_ERR, "error determining if user exists");
        return (0);
    }

    return (0);
}
